declare('fuzzy', {})
local time_map = {
	months  = {value = 2419200},
	weeks   = {value =  604800, noun = ' week'},
	days    = {value =   86400, noun = ' day'},
	hours   = {value =    3600, noun = ' hour'},
	minutes = {value =      60, noun = ' minute'},
	seconds = {value =       1, noun = ' second'}
}

local difftime = os.difftime
local floor = math.floor

function fuzzy.diff(b, a)
	local diff = difftime(b, a)
	if diff < 0 then return nil end
	
	local str, ftime = ''
	if (diff >= time_map.months.value) then
		return a

	elseif (diff >= time_map.weeks.value) then
		ftime = floor(diff / time_map_weeks.value)
		str = ftime..time_map.days.noun

	elseif (diff >= time_map.days.value) then
		ftime = floor(diff / time_map.days.value)
		str = ftime..time_map.days.noun

	elseif (diff >= time_map.hours.value) then
		ftime = floor(diff / time_map.hours.value)
		str = ftime..time_map.hours.noun

	elseif (diff >= time_map.minutes.value) then
		ftime = floor(diff / time_map.minutes.value)
		str = ftime..time_map.minutes.noun

	else
		ftime = diff
		str = ftime..time_map.seconds.noun
	end

	if (ftime > 1) then str = str..'s' end
	str = str..' ago'

	return str
end